/**
 ** @author: Ben Y. Zhao (ravenben@cs.berkeley.edu)
 ** @version: Release 1.1 CVS:$Revision: 1.7 $ $Date: 1999/09/10 00:12:34 $
 ** (c) 1999 by Ben Yanbin Zhao and the Regents of the University of California
 **/

package ninja.xset;

import java.util.*;
import ninja.*;
import java.io.*;
import org.w3c.dom.*;
import com.ibm.xml.parsers.DOMParser;

public class TestSET {

  protected Vector hPtr;
  protected SETserver server;

  /*  public TestSET (long refreshrate) {
      server = new SETserver(refreshrate);
      }*/
  public TestSET () {
    server = new SETserver();
  }
  
  protected boolean register(Document d) {
    return true;
  }
  
  protected boolean query(Document q) {
    return true;
  }
  
  public void test(String queryFile, String storPath) {
    Document d = null;;
    File path = null;
    String [] xmlFiles = null;
    
    path = new File(storPath);
    if ((xmlFiles = path.list(new ExtensionFilter("xml"))) == null) {
      System.out.println("Directory not found or inaccessible!");
      System.exit(-1);
    }
    try {
      DOMParser parser = new DOMParser();
      for (int i = 0; i < xmlFiles.length; i++) {
	System.out.println("*******************\n"+xmlFiles[i]+
			   " file loaded.");
	parser.parse(path+"/"+xmlFiles[i]);
	d = parser.getDocument();
	server.SETregister(d);
	parser.reset();
	//	server.printSET("SET");
      }
      //      System.out.println("FILES REGISTERED");
      // SETserver registration is done, now we query
      parser.parse(queryFile);
      d = parser.getDocument();
      hPtr = server.querySET(d);
    } catch (FileNotFoundException fnfe) {
      System.out.println("Query file not found!!");
      System.exit(-1);
    } catch (Exception pp) {
      pp.printStackTrace();
    }
    Enumeration e = null;
    if (hPtr != null) {
      e = hPtr.elements();
      ServiceEntry se = null;
      while (e.hasMoreElements()) {
	se = (ServiceEntry) e.nextElement();
	System.out.println("Service ID: "+se.getid());
	System.out.println("Found match!\n"+se.toString());
      }
    } else {
      System.out.println("NO MATCH!");
    }
    return;
  }
  
  public static void main(String argv[]) {
    TestSET ts = new TestSET();
    if (argv.length != 2) {
      System.err.println("Need two arguments, queryFile and path");
      System.exit(1);
    } else {
      ts.test(argv[0], argv[1]);
    }
    System.exit(0);
  }
}
