/**
 * @author: Ben Y. Zhao (ravenben@cs.berkeley.edu)
 ** @version: Release 1.1 CVS:$Revision: 1.4 $ $Date: 1999/09/10 00:12:36 $
 * (c) 1999 by Ben Yanbin Zhao and the Regents of the University of California
 */

package ninja.xset;

import java.io.*;
import java.util.Vector;
import java.util.Enumeration;
import java.rmi.RemoteException;
import com.ms.xml.om.*;
import com.ms.xml.util.*;

public class XSetDBComponent {
  private SETserver server;
  private Runtime run;

  public XSetDBComponent() {
  }

  public static void main(String [] argv) {
    XSetDBComponent xs = new XSetDBComponent();
    xs.run();
  }
  
  public void run() {
    server = new SETserver();
    System.out.println("XSetService: started.");
    run = Runtime.getRuntime();
    long time;
    Document d = null;

    try {
	String f1 ="/usr/home/ravenben/ninja/classpath/ninja/xset/printers/lw466.xml";
	String f2 ="/usr/home/ravenben/ninja/classpath/ninja/xset/lw466.xml";
	d = new Document();
	
	time = System.currentTimeMillis();
	d.load(SETutils.parseFile(f1));
	time = System.currentTimeMillis() - time;
	System.out.println("Parse time: "+time);

	time = System.currentTimeMillis();
	d.load(SETutils.parseFile(f2));
	time = System.currentTimeMillis() - time;
	System.out.println("Parse time2: "+time);

	time = System.currentTimeMillis();
	server.SETregister(d);
	time = System.currentTimeMillis() - time;
	System.out.println("Index time: "+time);
    } catch (FileNotFoundException fnfe) {
      System.err.println("Query file not found!");
      return;
    } catch (com.ms.xml.parser.ParseException pe) {
    }
  }

  public void XSetClearAll() {
    System.out.println("XSetClearAll request received!");
    server = new SETserver();
    System.out.println("XSet cleared.");
  }
}
