/**
 * @author: Ben Y. Zhao (ravenben@cs.berkeley.edu)
 ** @version: Release 1.1 CVS:$Revision: 1.5 $ $Date: 1999/09/10 00:12:36 $
 * (c) 1999 by Ben Yanbin Zhao and the Regents of the University of California
 */

package ninja.xset;

import java.io.*;
import java.util.Vector;
import java.util.Enumeration;
import java.rmi.RemoteException;
import com.ms.xml.om.*;
import com.ms.xml.util.*;

public class XSetDBMemory {
  private SETserver server;
  private Runtime run;

  private int filesindexed;
  private long memorystart;
  private long memoryleft;
  private long memorytotal;

  public XSetDBMemory() {
  }

  public static void main(String [] argv) {
    XSetDBMemory xs = new XSetDBMemory();
    xs.run();
  }
  
  public void run() {
    System.out.println("XSetService: started.");
    int load = 20;
    filesindexed = 0;
    run = Runtime.getRuntime();
    try {
      XSetClearAll();
      for (int i =0; i<load; i++) {
	  XSetAddFiles("/usr/home/research/xset/db/"+i);
      }
     } catch (Exception ex) {ex.printStackTrace();}
  }

  public void XSetAddFiles(String path) {
    //    System.out.println("XSetAddFiles request received!");
    File dir = new File(path);
    String [] xmlFiles = null;
    Document d = null;

    if ((xmlFiles = dir.list(new ExtensionFilter("xml"))) == null) {
      System.out.println("Directory not found or inaccessible!");
      return;
    }
    int i = 0;
    run.gc();
    memorystart = run.totalMemory() - run.freeMemory();
    try {
      for (i = 0; i < xmlFiles.length; i++) {
	d = new Document();
	d.load(SETutils.parseFile(path+"/"+xmlFiles[i]));
	server.SETregister(d);
	if ((i+1) % 100 == 0) {
	    run.gc();
	    memorytotal = run.totalMemory() - run.freeMemory() - memorystart;
	    System.out.println("Documents, Memory: "+(filesindexed+1)+"##"+
			       memorytotal);
	    memorystart = run.totalMemory() - run.freeMemory();
	}
	filesindexed++;
      }
    } catch (FileNotFoundException fnfe) {
      System.err.println("Query file not found!");
      return;
    } catch (com.ms.xml.parser.ParseException pe) {
      System.err.println("Parsing ERROR on: "+xmlFiles[i]);
    }
  }

  public void XSetClearAll() {
    System.out.println("XSetClearAll request received!");
    server = new SETserver();
    System.out.println("XSet cleared.");
  }

  public Vector XSetQuery(String xmlQuery) {
    //    System.out.println("XSetQuery request received!");
    Document d = new Document();
    Vector results = null;
    InputStream is = new ByteArrayInputStream(xmlQuery.getBytes());
    try {
      d.load(is);
      results = server.querySET(d);
    } catch (com.ms.xml.parser.ParseException pe) {
      System.err.println("Error parsing query string: \n"+xmlQuery);
    }
    return results;
  }
}
