/**
 ** @author: Ben Y. Zhao (ravenben@cs.berkeley.edu)
 ** @version: Release 1.1 CVS:$Revision: 1.8 $ $Date: 1999/09/10 00:12:37 $
 ** (c) 1999 by Ben Yanbin Zhao and the Regents of the University of California
 **/

package ninja.xset;

import java.util.Vector;
import org.w3c.dom.*;

public interface XSetServiceIF extends java.rmi.Remote {
  public void AddDocument(String xmlstring) 
    throws java.rmi.RemoteException; 
  //adding a single XML string to the dataset
  public void AddFiles(String path) 
    throws java.rmi.RemoteException;
  //adding an entire directory to the dataset
  public void AddFile(String filename)
    throws java.rmi.RemoteException;
  //adding one single file to the dataset
  
  public Vector QuerySE(String xmlQuery) 
    throws java.rmi.RemoteException;
  //query the server and get back a vector of ServiceEntry objects
  public Vector Query(String xmlQuery) 
    throws java.rmi.RemoteException;
  //query the server and get back a vector of XML strings
  public Vector Query(String xmlQuery, Vector tagVector)
    throws java.rmi.RemoteException;
  //query the server and get back a vector of hashtables with requested tags
  public Vector EnumerateTag(String [] pathArray) 
    throws java.rmi.RemoteException;
  //ask the server to return all existing values for a named tag in the index
  
  public void RemoveDocument(Document d) 
    throws java.rmi.RemoteException;
  //removes the document given the DOM document object
  public void RemoveDocument(String xml) 
    throws java.rmi.RemoteException;
  //removes the document given the canonical XML string representation
  public void ClearAll() 
    throws java.rmi.RemoteException;
  //clear the entire dataset
}
